How to upload a file in JavaScript

Uploading files in JavaScript enables users to submit documents, images, and other files to your server without page refreshes. As the creator of CoreUI with over 25 years of JavaScript development experience, I’ve implemented file uploads in countless production applications for user profiles and document management. The most reliable approach uses FormData with the fetch API to handle file uploads with proper content types. This method provides secure file transfer while maintaining full control over the upload process and error handling.

Use FormData with fetch API to upload files securely to your server.

function uploadFile(file) {
    const formData = new FormData()
    formData.append('file', file)

    return fetch('/api/upload', {
        method: 'POST',
        body: formData
    })
    .then(response => {
        if (!response.ok) {
            throw new Error('Upload failed')
        }
        return response.json()
    })
}

// Usage with file input
const fileInput = document.querySelector('input[type="file"]')
fileInput.addEventListener('change', async (event) => {
    const file = event.target.files[0]
    if (file) {
        try {
            const result = await uploadFile(file)
            console.log('Upload successful:', result)
        } catch (error) {
            console.error('Upload error:', error)
        }
    }
})

This code creates a FormData object and appends the selected file to it, then sends it via fetch to your upload endpoint. The FormData automatically sets the correct content type for multipart file uploads. The function returns a promise that resolves with the server response or rejects with an error for failed uploads.

Best Practice Note:

This is the upload mechanism we use in CoreUI dashboard components for file management features. Always validate file types and sizes both client-side and server-side to prevent security issues and ensure proper file handling.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

Subscribe to our newsletter
Get early information about new products, product updates and blog posts.
How to Redirect to a New URL Using JavaScript Redirect Techniques
How to Redirect to a New URL Using JavaScript Redirect Techniques

What are the three dots `...` in JavaScript do?
What are the three dots `...` in JavaScript do?

How to change opacity on hover in CSS
How to change opacity on hover in CSS

How to force a React component to re-render
How to force a React component to re-render

Answers by CoreUI Core Team

How to upload a file in React

File upload functionality is essential for modern React applications, from profile pictures to document management systems. As the creator of CoreUI with over 11 years of React development experience since 2014, I’ve implemented file uploads in countless enterprise applications. The most effective solution is to use a file input with onChange handler, store the file in state, and send it using FormData. This approach works seamlessly with any backend API and provides full control over the upload process.

Use a file input with FormData to upload files in React.

const [selectedFile, setSelectedFile] = useState(null)
const [uploading, setUploading] = useState(false)

const handleFileChange = (e) => {
  setSelectedFile(e.target.files[0])
}

const handleUpload = async () => {
  if (!selectedFile) return

  setUploading(true)
  const formData = new FormData()
  formData.append('file', selectedFile)

  try {
    const response = await fetch('/api/upload', {
      method: 'POST',
      body: formData
    })
    const data = await response.json()
    console.log('Upload successful:', data)
  } catch (error) {
    console.error('Upload failed:', error)
  } finally {
    setUploading(false)
  }
}

return (
  <div>
    <input type='file' onChange={handleFileChange} />
    <button onClick={handleUpload} disabled={!selectedFile || uploading}>
      {uploading ? 'Uploading...' : 'Upload'}
    </button>
  </div>
)

The file input’s onChange event provides the selected file through e.target.files[0], which is stored in state. FormData creates a multipart/form-data request that servers expect for file uploads. The append() method adds the file with a field name matching your API’s requirements. The upload button is disabled during upload and when no file is selected, preventing duplicate submissions.

Best Practice Note

This is the same reliable file upload pattern we use in CoreUI React components. For better UX, add file type and size validation before upload, display upload progress using XMLHttpRequest or axios with progress events, and show preview for image files to confirm selection before uploading.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author